高效检查多个命令的 Bash 退出状态
对于多个命令,是否有类似于 pipelinefail 的东西,例如 bash 中的“try”语句。我想做这样的事情:
echo "trying stuff"
try {
command1
command2
command3
}
并且在任何时候,如果任何命令失败,则退出并回显该命令的错误。我不想做类似的事情:
command1
if [ $? -ne 0 ]; then
echo "command1 borked it"
fi
command2
if [ $? -ne 0 ]; then
echo "command2 borked it"
fi
等等...或类似的事情:
pipefail -o
command1 "arg1" "arg2" | command2 "arg1" "arg2" | command3
因为我相信每个命令的参数(如果我错了,请纠正我)会互相干扰。这两种方法对我来说似乎非常冗长和令人讨厌,所以我在这里呼吁一种更有效的方法。
Is there something similar to pipefail for multiple commands, like a 'try' statement but within bash. I would like to do something like this:
echo "trying stuff"
try {
command1
command2
command3
}
And at any point, if any command fails, drop out and echo out the error of that command. I don't want to have to do something like:
command1
if [ $? -ne 0 ]; then
echo "command1 borked it"
fi
command2
if [ $? -ne 0 ]; then
echo "command2 borked it"
fi
And so on... or anything like:
pipefail -o
command1 "arg1" "arg2" | command2 "arg1" "arg2" | command3
Because the arguments of each command I believe (correct me if I'm wrong) will interfere with each other. These two methods seem horribly long-winded and nasty to me so I'm here appealing for a more efficient method.
如果你对这篇内容有疑问,欢迎到本站社区发帖提问 参与讨论,获取更多帮助,或者扫码二维码加入 Web 技术交流群。
绑定邮箱获取回复消息
由于您还没有绑定你的真实邮箱,如果其他用户或者作者回复了您的评论,将不能在第一时间通知您!
发布评论
评论(16)
您可以编写一个函数来启动并测试该命令。假设
command1
和command2
是已设置为命令的环境变量。You can write a function that launches and tests the command for you. Assume
command1
andcommand2
are environment variables that have been set to a command.“退出并回显错误”是什么意思?如果您的意思是希望脚本在任何命令失败时立即终止,那么只需
在脚本开头执行即可(但请注意下面的警告)。不要费心回显错误消息:让失败的命令来处理它。换句话说,如果你这样做:
并且 command2 失败,同时将错误消息打印到 stderr,那么看起来你已经实现了你想要的。 (除非我误解了您想要的内容!)
作为推论,您编写的任何命令都必须表现良好:它必须向 stderr 而不是 stdout 报告错误(问题中的示例代码将错误打印到 stdout)并且必须以非-失败时状态为零。
然而,我不再认为这是一个好的做法。
set -e
在不同版本的 bash 中改变了它的语义,虽然它对于简单的脚本来说工作得很好,但有太多的边缘情况,以至于它基本上无法使用。 (考虑如下内容:set -e; foo() { false; echo should not print; } ; foo && echo ok
这里的语义有些合理,但如果您将代码重构为依赖选项设置提前终止的函数,你很容易被咬。)IMO 最好写:或
What do you mean by "drop out and echo the error"? If you mean you want the script to terminate as soon as any command fails, then just do
at the start of the script (but note warning below). Do not bother echoing the error message: let the failing command handle that. In other words, if you do:
and command2 fails, while printing an error message to stderr, then it seems that you have achieved what you want. (Unless I misinterpret what you want!)
As a corollary, any command that you write must behave well: it must report errors to stderr instead of stdout (the sample code in the question prints errors to stdout) and it must exit with a non-zero status when it fails.
However, I no longer consider this to be a good practice.
set -e
has changed its semantics with different versions of bash, and although it works fine for a simple script, there are so many edge cases that it is essentially unusable. (Consider things like:set -e; foo() { false; echo should not print; } ; foo && echo ok
The semantics here are somewhat reasonable, but if you refactor code into a function that relied on the option setting to terminate early, you can easily get bitten.) IMO it is better to write:or
我有一组在我的 Red Hat 系统上广泛使用的脚本函数。它们使用
/etc/init.d/functions
中的系统函数来打印绿色[ OK ]
和红色[FAILED]
状态指示器。如果您想记录哪些命令失败,您可以选择将
$LOG_STEPS
变量设置为日志文件名。使用
输出
代码
I have a set of scripting functions that I use extensively on my Red Hat system. They use the system functions from
/etc/init.d/functions
to print green[ OK ]
and red[FAILED]
status indicators.You can optionally set the
$LOG_STEPS
variable to a log file name if you want to log which commands fail.Usage
Output
Code
无论如何,编写代码来检查每个命令是否成功的一种较短方法是:
它仍然很乏味,但至少是可读的。
For what it's worth, a shorter way to write code to check each command for success is:
It's still tedious but at least it's readable.
另一种方法是简单地将命令与
&&
连接在一起,以便第一个失败的命令阻止其余命令执行:这不是您在问题中要求的语法,但它是一个您所描述的用例的常见模式。一般来说,这些命令应该对打印失败负责,这样您就不必手动执行此操作(也许可以使用
-q
标志来在您不需要错误时消除错误)。如果您有能力修改这些命令,我会编辑它们以在失败时大喊大叫,而不是将它们包装在其他可以这样做的东西中。另请注意,您不需要执行以下操作:
您可以简单地说:
当您确实需要检查返回代码时,请使用算术上下文而不是
[ ... -ne
:An alternative is simply to join the commands together with
&&
so that the first one to fail prevents the remainder from executing:This isn't the syntax you asked for in the question, but it's a common pattern for the use case you describe. In general the commands should be responsible for printing failures so that you don't have to do so manually (maybe with a
-q
flag to silence errors when you don't want them). If you have the ability to modify these commands, I'd edit them to yell on failure, rather than wrap them in something else that does so.Notice also that you don't need to do:
You can simply say:
And when you do need to check return codes use an arithmetic context instead of
[ ... -ne
:不要创建运行程序函数或使用 set -e,而是使用陷阱:
陷阱甚至可以访问触发它的命令的行号和命令行。变量是
$BASH_LINENO
和$BASH_COMMAND
。Instead of creating runner functions or using
set -e
, use atrap
:The trap even has access to the line number and the command line of the command that triggered it. The variables are
$BASH_LINENO
and$BASH_COMMAND
.就我个人而言,我更喜欢使用轻量级方法,如此处所示;
用法示例:
Personally I much prefer to use a lightweight approach, as seen here;
Example usage:
我已经开发出一种几乎完美的尝试和方法。 bash 中的 catch 实现,允许您编写如下代码:
您甚至可以将 try-catch 块嵌套在其内部!
该代码是我的 bash 样板/框架的一部分。它进一步扩展了 try & 的想法。 catch 诸如带有回溯和异常的错误处理(以及其他一些不错的功能)。
这是只负责 try & 的代码。注意:
请随意使用、分叉和贡献 - 它位于 GitHub 上。
I've developed an almost flawless try & catch implementation in bash, that allows you to write code like:
You can even nest the try-catch blocks inside themselves!
The code is a part of my bash boilerplate/framework. It further extends the idea of try & catch with things like error handling with backtrace and exceptions (plus some other nice features).
Here's the code that's responsible just for try & catch:
Feel free to use, fork and contribute - it's on GitHub.
抱歉,我无法对第一个答案发表评论
但你应该使用新实例来执行命令: cmd_output=$($@)
Sorry that I can not make a comment to the first answer
But you should use new instance to execute the command: cmd_output=$($@)
对于偶然发现此线程的 fish shell 用户。
让
foo
是一个不“返回”(回显)值的函数,但它照常设置退出代码。为了避免在调用函数后检查
$status
,您可以这样做:如果它太长而无法放在一行中:
For fish shell users who stumble on this thread.
Let
foo
be a function that does not "return" (echo) a value, but it sets the exit code as usual.To avoid checking
$status
after calling the function, you can do:And if it's too long to fit on one line:
您可以在非 RedHat 系统上使用 @john-kugelman 的很棒的解决方案,方法是在他的代码中注释掉这一行:
然后,将以下代码粘贴到末尾。完全披露:这只是直接复制&粘贴上述文件的相关部分,取自 Centos 7。
在 MacOS 和 Ubuntu 18.04 上测试。
You can use @john-kugelman 's awesome solution found above on non-RedHat systems by commenting out this line in his code:
Then, paste the below code at the end. Full disclosure: This is just a direct copy & paste of the relevant bits of the above mentioned file taken from Centos 7.
Tested on MacOS and Ubuntu 18.04.
当我使用
ssh
时,我需要区分由连接问题引起的问题和errexit
(set -e
)模式下远程命令的错误代码。我使用以下函数:When I use
ssh
I need to distinct between problems caused by connection issues and error codes of remote command inerrexit
(set -e
) mode. I use the following function:如果您想在命令失败后立即以
错误代码 1
退出:一行:
请小心在
{
之后和}
之前添加一个空格如上图所示。额外信息:
请注意,您不能使用圆括号/括号,如下所示:
命令1 || (echo "command1 borked it" && exit 1)
因为
(exit 1)
将在子 shell 中运行。因此它将从子shell退出,但不会从父 shell退出。有关更多信息,请检查此答案:https://unix.stackexchange.com/a/172543/513474
If you want to exit with
error code 1
right after the command fails:One liner:
Be careful to add a space after
{
and before}
as shown above.Extra info:
Note that you cannot use round brackets/parentheses like this:
command1 || (echo "command1 borked it" && exit 1)
Because
(exit 1)
will run in subshell. So it will exit from subshell, but it will NOT exit from the parent shell.For more info, please check this answer: https://unix.stackexchange.com/a/172543/513474
以功能方式检查状态
用法:
输出
Checking status in functional manner
Usage:
Output
假设
or
Tedious它
产生
是。但可读性还不错。
suppose
either
or
yields
Tedious it is. But the readability isn't bad.